# bcexparse

FF6 BCEX Spoiler Log to JSON Parser

## Usage

This tool uses only the Python standard library; no packages are needed.

Grab the latest release from the "Releases" section of the source repo, then unzip and run:

`./main.py <spoiler log filename.txt>`

It's recommended to pipe the output to `jq` or a similar json parsing tool.

## Why?

The FF6 BCEX spoiler log format is extremely inconsistent and clearly designed purely for human consumption. Doing anything automated with it is difficult at best. This utility attempts to provide the middleware to turn the spoiler log into a data structure (in this case json) that can be parsed by another tool for any number of purposes.

Its original purpose was to allow the automation of validating the difficulty of a seed by checking that a seed contains specific tools needed at specific checkpoints in the game (for example: that the forced party for the Lethe River segment is capable of defending Banon).

Other uses can include presenting randomization data in a way it can be studied to create trackers and solvers, using the JSON data as a lens to create a differently formatted spoiler log with data redacted or altered, or creating a web front end that displays the spoiler data in a more friendly manner.

## Limitations

The parser is quite brittle since the inconsistency of the original spoiler log format requires it to make assumptions about data structures. It is likely future versions of BCEX will break it.

Additionally the tool only parses spoiler log data needed for known use-cases, so if you plan to use it you may need to request the inclusion of spoiler log sections. The tool can be expanded by adding new functions named `parse_SECTION` where `SECTION` is the full name of a section in the log, as presented in the log.

BCCE (The community revival of the BCEX project) is supported, but support is geared toward taking BCCE's spoiler logs and producing identical output to BCEX. This means stats are not their own data object, but are folded into character data just like BCEX outputs it. Remonsterate is supported and inserts its data into the monsters object.

BCCE is in active development and this may break at any time; see the first paragraph in this section.

## Known Support Gaps

These sections in the BCEX/BCCE spoiler logs currently have no logic and I'm aware of it. That doesn't mean sections *not* listed here have support; they may not and I'm not aware of them.

- MAGITEK
- DANCES
- ESPERS
- ITEM MAGIC
- ITEM EFFECTS
- COLOSSEUM
- SHOPS
- TREASURE CHESTS
- JUNCTIONS
